Codeforces Round #238 (Div. 1)

时间:2023-03-09 18:38:32
Codeforces Round #238 (Div. 1)

感觉这场题目有种似曾相识感觉,C题还没看,日后补上。一定要坚持做下去。

A
Unusual Product

题意:

给定一个n*n的01矩阵,3种操作,

1 i 将第i行翻转

2 i 将第i列翻转

3 询问矩阵第i行和第i列做向量乘法之和。

分析:

分析发现对于3的结果取决于对角线上1的个数num,即num%2,然后就很好做了,对于每次操作,只需要改变该行或该列后,对角线上仍然有多少个1.

代码:

 #pragma comment(linker, "/STACK:16777216")
#include <cstdio>
#include <iostream>
#include <cstring>
#include <queue>
#include <vector>
#include <cmath>
#define inf 0x0f0f0f0f
#define in freopen("data.txt", "r", stdin);
#define pb push_back
#define bug(x) printf("Line : >>>>%d\n", (x));
using namespace std;
typedef unsigned short US;
typedef long long LL;
const int maxn = ;
int vis[maxn]; int main(){ int n, q;
scanf("%d", &n);
int res = ;
for(int i = ; i< n; i++) for(int j = ; j < n; j++) {
int t;
scanf("%d", &t);
if(i == j) vis[i] = t, res += t;
}
scanf("%d", &q);
while(q--){
int t, x;
scanf("%d", &t);
if(t != ){
scanf("%d", &x);
vis[x] ^= ;
res += (vis[x] ? : -);
}
else{
cout<<res%;
}
}
cout<<endl;
return ;
}

B
Toy Sum

题意:

共有1,2,3到10^6这么些个数首先选出n个数,x1~xn,要从剩下的数中选出若干数满足灯饰sum{xi-1| 1 <= i <= n} = sum {s-yi|1 <= i <= m}

分析:

xi-1和s-yi分别表示的数到两端的距离。

那么对于xi如果离s一样的近的数没有被选中则优先选它,如果两端一样近的地方都选取了,先不管它。最后将能够选取的一样近的数都选取完毕后,再针对两端一样近的数都选了的情况,这时候也只要将两端一样近的从没选中的选进Y集合就行了。

上面这样似乎才是标准解法,可是我是dfs暴力求解,加了些剪枝,也能过。

我的代码:

 #pragma comment(linker, "/STACK:16777216")
#include <cstdio>
#include <iostream>
#include <cstring>
#include <bitset>
#include <algorithm>
#include <queue>
#include <vector>
#include <cmath>
#define inf 0x0f0f0f0f
#define in freopen("data.txt", "r", stdin);
#define pb push_back
#define bug(x) printf("Line : >>>>%d\n", (x));
using namespace std;
typedef unsigned short US;
typedef long long LL;
const int maxn = (int)1e6 + ;
LL a[maxn];
bitset<maxn> vis;
LL sum[maxn];
int ok;
vector<int> ans;
int s = (int)1e6; void dfs(int x, LL sm) {
if(ok) return;
if(sm == ) {
ok = ;
return;
}
int k = upper_bound(a+, a+x+, sm) - a;
k--;
for(int i = k; i >= && sum[i] >= sm; i--) {
ans.pb(s-a[i]);
dfs(i-, sm-a[i]);
if(ok) return;
ans.pop_back();
}
}
int main() { int n;
scanf("%d", &n);
LL tmp = ;
for(int i = ; i <= n; i++) {
int u;
scanf("%d", &u);
tmp += u-;
vis[u] = ;
} // cout<<tmp<<endl;
int cnt = ;
for(int i = s; i >= ; i--)
if(vis[i] == ) {
a[++cnt] = s-i;
// if(cnt <= 10)
// cout<<a[cnt]<<endl;
sum[cnt] = sum[cnt-] + s-i;
}
vis.reset();
if(tmp == ) {
cout<< <<endl;
cout<< << endl;
return ;
}
dfs(cnt, tmp);
printf("%d\n", ans.size()); for(int i = ; i < ans.size(); i++)
printf("%d%c", ans[i], i == ans.size()- ? '\n' : ' ');
return ;
}

D
Hill Climbing

题意:

每座山用一根垂直线段表示,有x,y两种属性,按照x递增给定n座山的xi和yi,每次在第i座山的时候只能够到达在视野范围内(这样说是没有问题的)的最右的一座山,然后两个人分别位于两座山上,问他们分别出发,沿着上面的原则确定的路线转移,直到两者到达同一座山。

分析:

首先要确定没座山能够到达的最右的一座山,除了最右的山没有可到达的山,每座山显然能到达另一座山,可以从右往左扫,建立单调栈,将第i座山与栈顶的斜率k1,栈顶与栈顶以下的一座山的斜率k2比较,如果k1 < k2将栈顶元素出栈。最后第i座山能够到达栈顶那座山,同时将i入栈。

这样会得到一棵树,对于每个询问,只需要询问他们的lca就是了。

注意:倍增法求lca的时候,应该在dfs子树的时候将fa[u][i]更新求出来。

代码:

#pragma comment(linker, "/STACK:16777216")
#include <cstdio>
#include <iostream>
#include <cstring>
#include <bitset>
#include <algorithm>
#include <queue>
#include <vector>
#include <cmath>
#define inf 0x0f0f0f0f
#define in freopen("data.txt", "r", stdin);
#define pb push_back
#define esp 1e-6
#define bug(x) printf("Line : >>>>%d\n", (x));
using namespace std;
typedef unsigned short US;
typedef long long LL;
const int maxn = (int)1e5 + ;
struct Po {
double x, y;
} h[maxn];
int st[maxn];
vector<int> g[maxn];
double cal(int x, int y) {
return (h[x].y-h[y].y)/(h[x].x-h[y].x);
}
int fa[maxn][], dep[maxn];
double dblcmp(double x) {
if(fabs(x) < esp) return ;
return x > ? : -;
}
void dfs(int u, int f) {
dep[u] = dep[f] + ;
fa[u][] = f;
for(int i = ; i < ; i++) {
fa[u][i] = fa[fa[u][i-]][i-];
}
for(int i = ; i < g[u].size(); i++) {
int v = g[u][i];
if(v == f)
continue;
// cout<<v<<endl;
dfs(v, u);
}
}
int lca(int x, int y) {
if(dep[x] < dep[y]) swap(x, y);
int d = dep[x]-dep[y];
for(int i = ; i < ; i++) if((d &(<<i)))
x = fa[x][i];
if(x != y) {
for(int i = ; i >= ; i--) if(fa[x][i] != fa[y][i])
x = fa[x][i], y = fa[y][i];
x = fa[x][];
}
return x;
}
int main() { int n, q;
scanf("%d", &n);
for(int i = ; i <= n; i++) {
scanf("%lf%lf", &h[i].x, &h[i].y);
}
int top = ;
for(int i = n; i >= ; i--) {
while(top >= && dblcmp(cal(i, st[top]) - cal(st[top], st[top-])) < )
top--;
if(top) {
g[st[top]].pb(i);
g[i].pb(st[top]);
}
st[++top] = i;
}
dfs(n, );
scanf("%d", &q);
for(int i = ; i <= q; i++) {
int u, v;
scanf("%d%d", &u, &v);
printf("%d%c", lca(u, v), i == q ? '\n' : ' ');
}
return ;
}

同样利用单调栈的一道题:HDU 5033 Building